#include <AD9850.h>

//************************************* 0.96 I2C ********************************************************
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET A7
Adafruit_SSD1306 display(OLED_RESET);
//************************************* 0.96 I2C ********************************************************


#define encoder0PinA 2
#define encoder0PinB 3

volatile unsigned int encoder0Pos = 10;
unsigned long krok = 1;
long x[] = {1, 10, 100, 1000, 10000, 100000, 1000000};
byte a = 0;

const int W_CLK_PIN = 7;
const int FQ_UD_PIN = 8;
const int DATA_PIN = 9;
const int RESET_PIN = 10;


long freq = 1000000;
double trimFreq = 124999500;
//volatile long freqq = 0;

int phase = 0;


void setup() {

  pinMode(encoder0PinA, INPUT); 
  pinMode(encoder0PinB, INPUT); 
  pinMode(4,INPUT);
  pinMode(13,OUTPUT);

  attachInterrupt(0, doEncoderA, FALLING);
  attachInterrupt(1, doEncoderB, FALLING);  


  //Serial.begin (9600);
  
  DDS.begin(W_CLK_PIN, FQ_UD_PIN, DATA_PIN, RESET_PIN);
  DDS.calibrate(trimFreq);
  DDS.setfreq(freq, phase);


//************************************* 0.96 I2C ********************************************************
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // wyświetlacz 128 x 32... ale 0-31 i 0-127
  display.display();
  delay(1);
  display.clearDisplay();

  // draw a single pixel
 // display.drawPixel(30, 32, WHITE);

  // text display tests
  display.setTextSize(1);
  display.setTextColor(WHITE);
  
                                                                    //for (int16_t i=display.height()-1; i>=0; i-=4) {
 //                  x1..y1...x2...y2.....kolor   (128 x64)
  //   display.drawLine(20,10, 80, 20, WHITE);
    display.display();
//************************************* 0.96 I2C **************************************************

}




void loop()
{
  text();
if (digitalRead(4) == LOW) 

           { 
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              delay(100);
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              delay(100);
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              a++;
              if (a == 7) {a=0;}
              
              delay(20);  
              krok = x[a];

              text();
           }

                        
}//end
//syntezaDDS();






  
 //detachInterrupt(0);    //Wyłącz przerwanie 0 EncoderA
 //detachInterrupt(1);    //Wyłącz przerwanie 1 EncoderB

 
 
 // attachInterrupt(0, doEncoderA, FALLING); //włącz P0 EncoderA
 // attachInterrupt(0, doEncoderB, FALLING); //włącz P1 EncoderB
  
// koniec void loop***************************



//----------------- Programy wykonawacze DDS plus nimus -----------------
 
void syntezaDDSplus()
{
freq = freq + krok;
DDS.setfreq(freq, phase);


  

/*
Serial.println (freq, DEC);
Serial.print ("    ");
Serial.println (krok, DEC);        
*/



}

 
void syntezaDDSminus()
{
freq = freq - krok;
DDS.setfreq(freq, phase);





/*
Serial.println (freq, DEC);
Serial.print ("    ");
Serial.println (krok, DEC);        
*/



}



//********************************************** text i2c wyswietlacz  ************************* 
void text() 

{
  display.clearDisplay();
  
  display.setTextColor(WHITE, BLACK); // 'inverted' text
  //display.println("3.9992");
  display.setTextSize(1);
  display.setCursor(55,0);
  //display.setTextColor(WHITE);
  display.println(krok);
  // display.drawLine(0, 0, 1, 63, WHITE);
 

  display.setTextSize(2);
  //display.setTextColor(WHITE);
  display.setCursor(10,30);
  display.println(freq);

   display.display();
  
}




 
void syntezaDDS()
{

}








//*************************************  PRZERWANIE A  *********************
void doEncoderA(){
  delay(10);
  if (digitalRead(encoder0PinA) == LOW) 
      { 
    
           if (digitalRead(encoder0PinB) == HIGH) 
            {  
             encoder0Pos = encoder0Pos - 1;         // CW
            syntezaDDSminus();
            
            } 
             
      }

     
  //Serial.print (krok, DEC);
  //Serial.print ("  ");  
  //Serial.println (freq, DEC);        


}

//********************************  PRZERWANIE B  ************************



void doEncoderB()
{
delay(10);
  
     if (digitalRead(encoder0PinB) == LOW) 
      {   

        if (digitalRead(encoder0PinA) == HIGH) 
        {  
          encoder0Pos = encoder0Pos + 1;         // CW
        syntezaDDSplus();
        } 
        
      }
   


}
//************************** KONIEC PRZERWAŃ **************************** 




 

